<?php

  $mn_root_dir = dirname(__FILE__);

  # check if news directory exists
  if (is_dir($mn_root_dir.'/data/news/')) {

    # everything seems to be fine, let's include some config files, functions, lang file and definitions
    include_once $mn_root_dir.'/data/databases/mn-db-config.php';
    include_once $mn_root_dir.'/stuff/inc/mn-functions.php';
    $lng = select_lang();
    include_once $mn_root_dir.'/stuff/lang/lang_'.$lng.'.php';
    include_once $mn_root_dir.'/stuff/inc/mn-definitions.php';
    
    # prepare 'show news' url, where we will point our internal MNews links
    $mn_link_path = (empty($mn_show_url)) ? $_SERVER["REQUEST_URI"] : $mn_show_url;
    $mn_show_path = generate_url($mn_link_path);



    
    
    $conf['news_count'] = (isset($mn_count)) ? $mn_count : $conf['news_count'];
    $conf['show_pagination'] = (isset($mn_pagination)) ? $mn_pagination : $conf['show_pagination'];
    $mn_cat = (!empty($mn_cat)) ? $mn_cat : $_GET["mn-cat"];
    $mn_requested_cats = explode(",", $mn_cat);



    if ($_GET["mode"] == "rss") {$mn_tmpl = 'rss';}
    if ($_GET["mn-page"] <= 0 || !is_numeric($_GET["mn-page"])) $_GET["mn-page"] = 1;





    if (!empty($_GET["mn-q"]) && (eregi("[!?\'$&/()=%*:;,.@\"#~|_+{}<>]", $_GET["mn-q"]))) {echo encoding($lang['search_forbidden']);}
    
    

    elseif ($mn_tmpl == 'menu') {
      if (file_exists("$mn_root_dir/".$file['categories'])) {
        $cats_file = file("$mn_root_dir/".$file['categories']);
        echo "\n\n\t\t<ul class='mn-menu'>\n";
        foreach ($cats_file as $single_line) {
          $cat_data = explode("|", $single_line);
          if (substr($cat_data[0], 0, 2) == "<?") continue;
          else {
            echo "\t\t\t<li><a href='".$mn_show_path."mn-cat=".$cat_data[0]."'>".encoding(trim($cat_data[1]))."</a></li>\n";
          }
        }
        echo "\t\t</ul>\n\n";
      }
      else echo encoding($lang['cats_no_file']);
    }
    
    
    
    
    elseif ($mn_tmpl == 'archive') {
      if (empty($mn_start_month) && empty($mn_start_year)) {
        $mnews_dir = dir("$mn_root_dir/data/news/");
        while($mnews_dir_file = $mnews_dir->read()) {
          if ($mnews_dir_file == "." || $mnews_dir_file == "..") continue;
          $file_name = explode(".", $mnews_dir_file);
          if ($file_name[0] > time()) continue;
          else $archive_files[] = $file_name[0];
        }
        if (!empty($archive_files)) {
          sort($archive_files);
          $start_month = date("n", $archive_files[0]);
          $start_year = date("Y", $archive_files[0]);
        }
        else {$start_month = 0; $start_year = 0;}
      }
      
      else {
        $start_month = $mn_start_month;
        $start_year = $mn_start_year;
      }

      if (($start_month > 0) && ($start_month < 13) && ($start_year > 1990)) {
        $mn_archive_style = (isset($mn_archive_style)) ? $mn_archive_style : "m/Y";
        echo "\n\n\t\t<ul class='mn-archive'>\n";      
        for ($m = $start_month; mktime(0, 0, 0, $m, 1, $start_year) <= time(); $m++) { 
          $t = mktime(0, 0, 0, $m, 1, $start_year);
          echo "\t\t\t<li><a href='".$mn_show_path."mn-archive=".date("Y-m", $t)."'>".date($mn_archive_style, $t)."</a></li>\n";
          
        }
        echo "\t\t</ul>\n\n";
      }
    }





    elseif ($mn_tmpl == 'search') {
      echo "<form action='".$mn_show_path."' method='get' class='mn-search-form'><input type='text' name='mn-q' value='' /> <input type='submit' class='submit' value='".$lang['search_search']."' /></form>";
    }





    else {
      # here we can start to work with news directory
      # first of all, we will open the directory, read it and put news files into an array
      $mnews_dir = dir("$mn_root_dir/data/news/");
      
      if (isset($_GET["mn-id"]) && file_exists("$mn_root_dir/data/news/".$_GET["mn-id"].".txt")) {
        $news_files[] = $_GET["mn-id"];
        $check_comments = true;
      }
      else {
        while($mnews_dir_file = $mnews_dir->read()) {
          if ($mnews_dir_file == "." || $mnews_dir_file == "..") continue; # here we remove items - supdirectory and actuall folder
          $file_content = file_get_contents("$mn_root_dir/data/news/$mnews_dir_file");
          if (file_exists("$mn_root_dir/data/articles/$mnews_dir_file")) $file_full_content = file_get_contents("$mn_root_dir/data/articles/$mnews_dir_file");
          else $file_full_content = "";
          $file_item = explode ("|", $file_content);
          $file_name = explode(".", $mnews_dir_file);
          if ($file_name[0] > time()) continue; # check, if it's news, that has been already published. We don't want "future news"
          if (!empty($mn_cat) && (!in_array($file_item[2], $mn_requested_cats))) continue;
          if (isset($_GET["mn-author"]) && ($_GET["mn-author"] != $file_item[1])) continue;
          if (isset($_GET["mn-archive"]) && ($_GET["mn-archive"] != date("Y-m", $file_name[0]))) continue;
          if (isset($_GET["mn-q"]) && (strlen($_GET["mn-q"]) > 2) && (stripos($file_item[0], $_GET["mn-q"]) === false) && (stripos($file_item[7], $_GET["mn-q"]) === false) && (stripos($file_full_content, $_GET["mn-q"]) === false)) continue;
          if (!empty($file_item[5]) && $file_item[5] == '2') continue;
          $news_files[] = $file_name[0]; # when file seems to be ok, we will add it to array "$news_files"
        }
        $check_comments = false;
      }
  
  
  
  
  
      # first, we need to check, if the are some news to be show
      if (!empty($news_files)) {
  
  
        sort($news_files); # we need to sort news from oldest to youngest
        $news_files = array_reverse($news_files); # and reverse it to publish newest news first
  
  
        # how many news do we have together?
        $count = count($news_files);
        
        if ($conf['show_pagination']) {
          $news_per_page = isset($mn_count) ? $mn_count : $conf['news_count'];
          $pages_tmpl_content = "";
          $mn_pagination_path = $mn_show_path;
          if (isset($_GET["mn-cat"])) $mn_pagination_path = $mn_pagination_path."mn-cat=".$_GET["mn-cat"]."&amp;";
          if (isset($_GET["mn-archive"])) $mn_pagination_path = $mn_pagination_path."mn-archive=".$_GET["mn-archive"]."&amp;";
          if (isset($_GET["mn-q"])) $mn_pagination_path = $mn_pagination_path."mn-q=".$_GET["mn-q"]."&amp;";
    
    
          require_once $mn_root_dir.'/stuff/inc/paginator.class.php';
          $pages = new Paginator;
          $pages->items_total = $count;
          $pages->items_per_page = $news_per_page;
          $pages->current_page = $_GET["mn-page"];
          $pages->show_path = $mn_pagination_path;
          $pages->paginate();
          $pages_tmpl_content = $pages->display_pages();
          
          $j = ( ($_GET["mn-page"] - 1) * $conf['news_count'] );
          $max = ( ($count - $j) > $conf['news_count'] ) ? ( $j + $conf['news_count'] ) : $count;
          
          if ($j == 0 && $max == $count) $conf['show_pagination'] = false;
        }
        else {
          $j = 0;
          $max = $conf['news_count'];
        }
  
  
  
  
                
        # yeah... Let's make our news look cool and cute =)    ]:-> (evil smile)
        $mnews_result = "";
        for ($i = $j; $i <= $max-1; $i++) {
  
          $news_content = file_get_contents("$mn_root_dir/data/news/".$news_files[$i].".txt");
          $news_text = explode("|", $news_content);
          $perm_link = $mn_show_path."mn-id=".$news_files[$i];
          $title_link = "<a href='".$mn_show_path."mn-id=".$news_files[$i]."'>".check_text($news_text[0])."</a>";
          $title_plain = check_text($news_text[0]);
          if (file_exists("$mn_root_dir/data/articles/".$news_files[$i].".txt")) {
            $link = "<a href='".$mn_show_path."mn-id=".$news_files[$i]."'>".$lang['gen_link_full_story']."</a>";
            $full_story = file_get_contents("$mn_root_dir/data/articles/".$news_files[$i].".txt");
            $title = "<a href='".$mn_show_path."mn-id=".$news_files[$i]."'>".check_text($news_text[0])."</a>";
          }
          else {
            $link = "";
            $title = check_text($news_text[0]);
          }
  
  
          $users_file = file("$mn_root_dir/".$file['users']);
          foreach ($users_file as $single_line) {
            $user_data = explode("|", $single_line);
            if ($user_data[0] == $news_text[1]) $author = $user_data[1];
            else continue;
          }
          if (empty($author)) $author = "<em>".$lang['users_anonym']."</em>";
  
  
          if (file_exists("$mn_root_dir/".$file['categories'])) {
            $cats_file = file("$mn_root_dir/".$file['categories']);
            unset($category);
            foreach ($cats_file as $single_line) {
              $cat_data = explode("|", $single_line);

              if ($cat_data[0] == $news_text[2]) {
                $category = "<a href='".$mn_show_path."mn-cat=".$cat_data[0]."'>".trim($cat_data[1])."</a>";
                $category_name = trim($cat_data[1]);
              }
              else continue;
            }
          }
          else {$category = ""; $category_name = "";}
          
          
          
          if (file_exists("$mn_root_dir/data/comments/".$news_files[$i].".txt")) {
            $comments_file = file("$mn_root_dir/data/comments/".$news_files[$i].".txt");
            unset($comments);
            $j=0;
            foreach ($comments_file as $single_line) {
              $j++;
            }
            $comments = $j;
          }
          else {$comments = 0;}
          
          
          
          
          if ($check_comments) {
            if ($news_text[4] == '1') {$show_comments = '1';}
            else {$show_comments = '2';}
          }
          else {$show_comments = '0';}
  



          if ($temp['mnews_view'] == 'admin' || (($conf['admin_icons'] == true) && isset($_COOKIE["mn_user_name"]) && ($mn_tmpl !== 'rss') && ($temp['mnews_view'] !== 'mn-edit'))) {
            $title .= " <a href='".$conf['mnews_url_path']."/mn-news.php?mode=edit&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/edit.png' alt='edit' title='".$lang['news_edit_news']."' /></a> <a href='".$conf['mnews_url_path']."/mn-news.php?mode=delete&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/cross.png' alt='delete' title='".$lang['news_delete_news']."' /></a>";
            $title_plain .= " <a href='".$conf['mnews_url_path']."/mn-news.php?mode=edit&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/edit.png' alt='edit' title='".$lang['news_edit_news']."' /></a> <a href='".$conf['mnews_url_path']."/mn-news.php?mode=delete&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/cross.png' alt='delete' title='".$lang['news_delete_news']."' /></a>";
            $title_link .= " <a href='".$conf['mnews_url_path']."/mn-news.php?mode=edit&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/edit.png' alt='edit' title='".$lang['news_edit_news']."' /></a> <a href='".$conf['mnews_url_path']."/mn-news.php?mode=delete&amp;id=".$news_files[$i]."'><img src='".$conf['mnews_url_path']."/stuff/img/icons/cross.png' alt='delete' title='".$lang['news_delete_news']."' /></a>";
          }
          elseif ($mn_tmpl == 'rss') {
            $title = htmlspecialchars($title);
            $news_text[7] = htmlspecialchars($news_text[7]);
          }
          
  


          $mnews_tmpl_search = array(
            '/\{TITLE}/is',
            '/\{TITLE_LINK}/is',
            '/\{TITLE_PLAIN}/is',
            '/\{TEXT}/is',
            '/\{TEXT_FULL}/is',
            '/\{AUTHOR}/is',
            '/\{CATEGORY}/is',
            '/\{CATEGORY_NAME}/is',
            '/\{LINK}/is',
            '/\{PERM-LINK}/is',
            '/\[PERM-LINK\](.*?)\[\/PERM-LINK\]/is',
            '/\{COUNTER}/is',
            '/\{COMMENTS}/is',
            '/\{ID}/is',
            '/\{DATE}/is',
            '/\{DATE_US}/is',
            '/\{DATE_DAY}/is',
            '/\{DATE_DAY_ABBR}/is',
            '/\{DATE_MONTH}/is',
            '/\{DATE_MONTH_ABBR}/is',
            '/\{DATE_YEAR}/is',
            '/\{TIME}/is',
            '/\{TIME_US}/is',
            '/\{TIME_HOUR}/is',
            '/\{TIME_HOUR_US}/is',
            '/\{TIME_MIN}/is',
            '/\{TIME_AMPM}/is',
            '/\{PUBDATE}/is'
          );
          $mnews_tmpl_replace = array( 
            $title,
            $title_link,
            $title_plain,
            strip_slashes($news_text[7]),
            strip_slashes($full_story),
            $author,
            $category,
            $category_name,
            $link,
            $mn_show_path."mn-id=".$news_files[$i],
            '<a href="'.$perm_link.'">$1</a>',
            $news_text[3],
            $comments,
            $news_files[$i],
            date("j.n.Y", ($news_files[$i])),
            date("m/d/y", ($news_files[$i])),
            date("j", ($news_files[$i])),
            date("D", ($news_files[$i])),
            date("n", ($news_files[$i])),
            date("M", ($news_files[$i])),
            date("Y", ($news_files[$i])),
            date("H:i", ($news_files[$i])),
            date("h:i a", ($news_files[$i])),
            date("H", ($news_files[$i])),
            date("h", ($news_files[$i])),
            date("i", ($news_files[$i])),
            date("a", ($news_files[$i])),
            date("D, d M Y H:i:s", ($news_files[$i]))." GMT"
          );




          if ($temp['mnews_view'] == 'admin') {
            $mnews_tmpl = (isset($_GET["mn-id"]) && file_exists("$mn_root_dir/data/news/".$_GET["mn-id"].".txt")) ? $def['default_article_tmpl'] : $def['default_main_tmpl'];
          }
          elseif ($temp['mnews_view'] == 'mn-edit') {
            $mnews_tmpl = (isset($_GET["mn-id"]) && file_exists("$mn_root_dir/data/news/".$_GET["mn-id"].".txt")) ? $def['default_article_tmpl'] : $def['mnews_admin_tmpl'];
          }
          elseif ($mn_tmpl == 'rss') {
            $mnews_tmpl = file_get_contents("$mn_root_dir/".$file['rss_tmpl']);
          }
          elseif (isset($mn_cat) && !isset($_GET["mn-id"])) {
            $mnews_tmpl = file_get_contents("$mn_root_dir/".$file['category_tmpl']);
          }
          elseif (isset($_GET["mn-id"]) && file_exists("$mn_root_dir/data/news/".$_GET["mn-id"].".txt")) {
            $mnews_tmpl = file_get_contents("$mn_root_dir/".$file['article_tmpl']);

            if (file_exists("$mn_root_dir/data/articles/".$_GET["mn-id"].".txt") && ($conf["article_counter"]) && !isset($_COOKIE["mn_user_name"]) && is_writeable("$mn_root_dir/data/news/".$_GET["mn-id"].".txt")) {
              $file_counter_content = file_get_contents("$mn_root_dir/data/news/".$_GET["mn-id"].".txt");
              $fc_item = explode ("|", $file_counter_content);
              if (empty($fc_item[3])) $fc_item[3] = 0;
              $new_fc_content = $fc_item[0]."|".$fc_item[1]."|".$fc_item[2]."|".($fc_item[3]+1)."|".$fc_item[4]."|||".$fc_item[7];
              $new_fc_file = @fopen("$mn_root_dir/data/news/".$_GET["mn-id"].".txt", "w");
              @flock($new_fc_file, 2);
              @fwrite($new_fc_file, $new_fc_content);
              @fclose($new_fc_file);
            }

          }
          else {
            $mnews_tmpl = file_get_contents("$mn_root_dir/".$file['main_tmpl']);
          }




          if (file_exists("$mn_root_dir/data/articles/".$news_files[$i].".txt")) {
            $mnews_tmpl = preg_replace('/\[LINK\](.*?)\[\/LINK\]/is', '<a href="'.$perm_link.'">$1</a>', $mnews_tmpl);
          }
          else {
            $mnews_tmpl = preg_replace('/\[LINK\](.*?)\[\/LINK\]/is', '', $mnews_tmpl);
          }
          $mnews_result .= preg_replace($mnews_tmpl_search, $mnews_tmpl_replace, $mnews_tmpl);
          if ($conf['news_format'] == 'html' && $temp['mnews_view'] !== 'admin') $mnews_result = str_replace(" />", ">", $mnews_result);
          if ($mn_tmpl == 'rss') {
            $mnews_result = str_replace('</a>', '&lt;/a&gt;', $mnews_result);
            $mnews_result = str_replace('">', '&quot;&gt;', $mnews_result);
            $mnews_result = str_replace('<a href="', '&lt;a href=&quot;', $mnews_result);
          }
        }
  
  
  


        $pages_tmpl_search = array( 
          '/\{PAGES}/is',
          '/\{NEXT}/is',
          '/\{PREVIOUS}/is'
        );
        $pages_tmpl_replace = array( 
          $pages_tmpl_content,
          $next_page,
          $previous_page
        );
        
        if ($temp['mnews_view'] == 'admin') {$pages_tmpl = $def['default_pagination_tmpl'];}
        else {$pages_tmpl = file_get_contents("$mn_root_dir/".$file['pagination_tmpl']);}
  
        $pages_result = preg_replace($pages_tmpl_search, $pages_tmpl_replace, $pages_tmpl);
        if ($conf['news_format'] == 'html' && $temp['mnews_view'] !== 'admin') $pages_result = str_replace(" />", ">", $pages_result);








        // ------------- COMMENTS ---------------- //
        if (isset($temp['mnews_view']) || (!$conf['comments']) || $show_comments == '0') {
          $comments_result = "";
        }
        
        else {
          $article_id = $_GET["mn-id"];
          $comments_result = "";

          if (($show_comments !== '0') && ($conf['comments']) && !isset($temp['mnews_view'])) {

            $comments_content = @file_get_contents("$mn_root_dir/data/comments/$article_id.txt");
            $comments_content = trim($comments_content);
            if (file_exists("$mn_root_dir/data/comments/$article_id.txt") && !empty($comments_content)) {
              $comments_file = file("$mn_root_dir/data/comments/$article_id.txt");

              $comments_array = "";
              foreach ($comments_file as $single_line) {$comments_array[] = $single_line;}
              if ($conf['comments_order'] == 'reverse') $comments_array = array_reverse($comments_array);
              
              $k = 1;
              foreach ($comments_array as $single_comment) {
                $comment = explode("|", $single_comment);
                $author = $comment[1];
                $comment_admin_tools = (isset($_COOKIE["mn_user_name"])) ? "<a href='".$conf['mnews_url_path']."/mn-comments.php?mode=edit&amp;file=".$_GET["mn-id"]."&amp;id=".$comment[0]."'>e</a> <a href='".$conf['mnews_url_path']."/mn-comments.php?mode=delete&amp;file=".$_GET["mn-id"]."&amp;id=".$comment[0]."'>x</a>" : "";
                $comments_tmpl_search = array(
                  '/\{COMMENT_ID}/is',
                  '/\{COMMENT_NUM}/is',
                  '/\{AUTHOR}/is',
                  '/\{EMAIL}/is',
                  '/\{WWW}/is',
                  '/\{TEXT}/is',
                  '/\{IP_ADDRESS}/is',
                  '/\{HOST}/is',
                  '/\{BROWSER}/is',
                  '/\{DATE}/is',
                  '/\{TIME}/is',
                  '/\{DATE_US}/is',
                  '/\{TIME_US}/is',
                  '/\{COMMENT_ADMIN_TOOLS}/is',
                );
                $comments_tmpl_replace = array(
                  $comment[0],
                  $k,
                  $author,
                  $comment[2],
                  $comment[3],
                  $comment[10],
                  $comment[8],
                  $comment[9],
                  $comment[7],
                  date("j.n.Y", ($comment[0])),
                  date("H:i", ($comment[0])),
                  date("m/d/y", ($comment[0])),
                  date("h:i a", ($comment[0])),
                  $comment_admin_tools,
                );
                
                $k++;
                $comments_tmpl = file_get_contents("$mn_root_dir/".$file['comments_tmpl']);
                
                $target = ($conf['comments_links'] == 'blank') ? ' target="_blank"' : '';
                if (!empty($comment[2])) {$comments_tmpl = preg_replace('/\[EMAIL\](.*?)\[\/EMAIL\]/is', '<a href="mailto:'.$comment[2].'">$1</a>', $comments_tmpl);}
                else {$comments_tmpl = preg_replace('/\[EMAIL\](.*?)\[\/EMAIL\]/is', '', $comments_tmpl);}
                if (!empty($comment[3])) {$comments_tmpl = preg_replace('/\[WWW\](.*?)\[\/WWW\]/is', '<a href="'.$comment[3].'"'.$target.'>$1</a>', $comments_tmpl);}
                else {$comments_tmpl = preg_replace('/\[WWW\](.*?)\[\/WWW\]/is', '', $comments_tmpl);}
              
                $comments_result .= preg_replace($comments_tmpl_search, $comments_tmpl_replace, $comments_tmpl);
              }
              $comments_result = comment_format($comments_result);
            }
            elseif ($show_comments == '2') $comments_result .= "";
            else $comments_result .= $lang['comm_no_comments'];
          }
          
          else $comments_result = "<div class='mn-comment-info'>".$lang['comm_comments_forbidden']."</div>";
        }
        if ($conf['news_format'] == 'html' && $temp['mnews_view'] !== 'admin') $comments_result = str_replace(" />", ">", $comments_result);



  





        if ($mn_tmpl == 'rss') {
          $domain = explode('/', $conf['mnews_url_path']);
          header ("Content-Type: text/xml");
          echo "<?xml version='1.0' encoding='utf-8'?".">\n<rss version='2.0'>\n<channel>\n\t<title>".$domain[2]." - ".$lang['news_news']."</title>\n\t<link>http://".$domain[2]."/</link>\n\t<description>".$lang['gen_rss_description']." ".$domain[2]."</description>\n\t<language>".$conf['lang']."</language>\n\n".$mnews_result."\n</channel>\n</rss>";
        }
        
        else {  
          # ok, so here is the final result and let's show it to the rest of world.
          if (isset($_GET["mn-q"]) && (strlen($_GET["mn-q"]) > 2)) echo "<p class='mn-found-info'>".str_replace("%s%", "\"<strong>".$_GET["mn-q"]."</strong>\"", encoding($lang['search_found']))."</p>";
          echo encoding($mnews_result);
          echo "\n\n<!--    " . $lang['gen_powered_by'] . " MNews " . $def['mnews_version'] . "   :   http://mnews.php5.sk/     -->\n\n";
          if ($conf['comments'] && isset($_GET["mn-id"]) && $temp['mnews_view'] != 'admin') {
            echo "<div id='mn-comments'>\n";
            echo encoding($comments_result);
            if ($show_comments == '1') {include_once $mn_root_dir.'/stuff/tmpl/comment-form.php';}
            else {echo "<div class='mn-comment-info'>".encoding($lang['comm_comments_forbidden'])."</div>";}
            echo "\n</div>";
          }
          if ($conf['show_pagination']) echo encoding($pages_result);
          if ($conf['powered_by_line'] && empty($temp['mnews_view'])) echo "<p style='text-align: center; margin: 5px 0; font-size: 0.9em;'>Powered by <a href='http://mnews.php5.sk'>MNews</a>!</p>";
          # PS: "Powered by" line can be easily removed in MNews configuration. You don't have to delete it here.
        }
  
  
  
  
  
      }
      else {
        echo "<p class='mn-no-news'>";
        echo (isset($_GET["mn-q"])) ? str_replace("%s%", "\"<strong>".$_GET["mn-q"]."</strong>\"", encoding($lang['search_no_news'])) : encoding($lang['gen_no_news']);
        echo "</p>";
      }
    }
  }
  else echo "Ooops! An error has occurred! Contact administrator and tell him to contact <a href='mailto:mylann@gmail.com'>mylan</a>.";
  
  unset($mn_tmpl, $category, $comments, $mn_show_url, $check_comments, $show_comments, $mn_cat, $news_files);
?>
