<?php

if (defined('IN_MNews')) {


  function user_session() {
    if ($_SESSION["mn_logged"]) {
      global $def;
      if (($_SESSION["mn_user_time"] + ($def['max_logged_time']*60)) >= time()) {
        $_SESSION["mn_user_time"] = time();
        return true;
      }
      else {
        session_destroy();
        header("location: ./mn-login.php?back=loggedout");
        exit;
      }
      
    }
  
    else {
      if (isset($_GET["mode"]) && !isset($_GET["file"]) && isset($_GET["id"])) $redir = "?redir=news|".$_GET["mode"]."|".$_GET["id"]."|";
      elseif (isset($_GET["mode"]) && isset($_GET["file"]) && isset($_GET["id"])) $redir = "?redir=comments|".$_GET["mode"]."|".$_GET["id"]."|".$_GET["file"];
      else $redir = "";
      session_destroy();
      header("location: ./mn-login.php".$redir);
      exit;
    }
  }
  
  
  
  function check_install() {
    global $file;
    if (file_exists("./mn-install.php") && !file_exists("./".$file['users'])) {
      session_destroy();
      header("location: ./mn-install.php");
      exit;
    }
    elseif (file_exists("./mn-install.php") && !file_exists("./".$file["comments_tmpl"])) {
      session_destroy();
      header("location: ./mn-install.php?update");
      exit;
    }
    elseif (file_exists("./mn-install.php") && file_exists("./".$file['users'])) {
      session_destroy();
      $users_file = file_get_contents("./".$file['users']);
      $users_content = explode("|", $users_file);
      if (empty($users_content[3])) {
        header("location: ./mn-install.php");
        exit;
      }
      else {
        header("location: ./mn-login.php?mode=install-file");
        exit;
      }
    }
  }


}





function select_lang() {
  global $conf, $languages;

  if (isset($_SESSION["mn_lang"])) {
    $sel_lang = $_SESSION["mn_lang"];
  }
  
  elseif (isset($_COOKIE["mn_lang"]) && ($_COOKIE["mn_lang"] != $conf['lang'])) {
    $sel_lang = $_COOKIE["mn_lang"];
    $_SESSION["mn_lang"] = $sel_lang;
    @setcookie("mn_lang", $sel_lang, time()+60*60*24*31);
  }
  
  elseif (!isset($conf['lang']) || empty($conf['lang'])) {
    $sel_lang = 'sk';
  }
  
  else {
    $sel_lang = $conf['lang'];
  }
  
  return $sel_lang;
}





function encoding($str) {
  global $conf, $def;
  if ($conf['news_encoding'] != 'utf-8' && (!$_SESSION["mn_logged"])) {
    if ($def['php_version'] == 5) {
      return iconv("utf-8", $conf['news_encoding'], $str);      
    }
    elseif ($def['php_version'] != 5 && $conf['news_encoding'] == 'cp1250') {
      return utf2win($str);
    }
    elseif ($def['php_version'] != 5 && $conf['news_encoding'] == 'iso-8859-2') {
      return utf2iso($str);
    }
  }
  else return $str;
}




// Function generate_url()
function generate_url($url_in) {
  $url_part = explode("?", $url_in);
  $url_temp = (empty($url_part[1])) ? $url_in."?" : $url_in."&";

  $url_search = array("mn-page=".$_GET["mn-page"], "mn-cat=".$_GET["mn-cat"], "mn-id=".$_GET["mn-id"], "mn-comments=".$_GET["mn-comments"], "mn-q=".$_GET["mn-q"], "mn-archive=".$_GET["mn-archive"], "&&", "?&", "&");
  $url_replace = array("", "", "", "", "", "", "&", "?", "&amp;");

  $final_url = str_replace($url_search, $url_replace, $url_temp);
  return $final_url; 
}





function PasswordGenerator($length) {
  $vowels = array('a','e','i','o','u','y','A','E','I','O','U','Y');
  $cons = array('b','c','d','g','h','j','k','l','m','n','p','r','s','t','u','v','w','tr','cr','br','fr','th','dr','ch','ph','wr','st','sp','sw','pr','sl','cl');
  $num_vowels = count($vowels);
  $num_cons = count($cons);
  $password = '';
  for($i = 0; $i < $length; $i++)
    $password .= $cons[rand(0, $num_cons - 1)] . $vowels[rand(0, $num_vowels - 1)];
  return substr($password, 0, $length);
}

 # vlastná výroba, vracia heslo dlhé v určitom rozpätí vytvorené z aktuálneho času v unix formáte
function PasswordGenerator2($min, $max) {
  $heslo = mictotime();
  $heslo = md5($heslo);
  $dlzka = rand($min, $max);
  return substr($heslo, 0, $dlzka);
}





# skript check_mail je použitý z adresy http://www.phpit.net/code/valid-email/
function check_email($email) {
  if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
    return false;
  }
  $email_array = explode("@", $email);
  $local_array = explode(".", $email_array[0]);
  for ($i = 0; $i < sizeof($local_array); $i++) {
     if (!ereg("^(([A-Za-z0-9!#$%&#038;'*+/=?^_`{|}~-][A-Za-z0-9!#$%&#038;'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i])) {
      return false;
    }
  }
  if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) {
    $domain_array = explode(".", $email_array[1]);
    if (sizeof($domain_array) < 2) {
        return false; // Not enough parts to domain
    }
    for ($i = 0; $i < sizeof($domain_array); $i++) {
      if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) {
        return false;
      }
    }
  }
  return true;
}

function check_url($url) {
  if (empty($url) || ($url == "http://")) {return "";}
  else {
    $url = str_replace("|", "", $url);
    $find = HtmlSpecialChars($url);
    $http = substr_count($find,"http://");
    if ($http == 1) {return $find;}
    else {return "http://".$find;}
  }
}







 # Pridanie slashes v závislosti na zapnutých get_magic_quotes_gpc()
function add_slashes($str) {
  return (get_magic_quotes_gpc() ? $str : addslashes($str));
}


 # Odstránenie slashes v závislosti na zapnutých get_magic_quotes_gpc()
function strip_slashes($str) {
  return (get_magic_quotes_gpc() ? stripslashes($str) : $str);
}

function check_text($str) {
  $str = strip_slashes($str);
  $str = trim($str);
  $str = htmlspecialchars($str);
  $str = str_replace("|", "&brvbar;", $str);
  return $str;
}




function mn_highlight_string ($str) {
  $str = htmlspecialchars_decode($str);
  $str = preg_replace('/\[br\]/is', "\n", $str);
  $str = preg_replace('/\<br \/\>/is', "\n", $str);
  return highlight_string($str, true);
}

//formátovanie pomocou bbtagov
function comment_format ($str) {
  global $conf;
  $target = ($conf['comments_links'] == 'blank') ? " target='_blank'" : "";
  if ($conf['comments_auto_links']) $str = do_clickable($str);
  
  $bb_search = array(
    '#\[code\](.*?)\[\/code\]#ie',
    '/\[br\]/is',
    '/\[b\](.*?)\[\/b\]/is',
    '/\[i\](.*?)\[\/i\]/is',
    '/\[u\](.*?)\[\/u\]/is',
    '/\[url\=(.*?)\](.*?)\[\/url\]/is',
    '/\[url\](.*?)\[\/url\]/is',
    '/\[mail\=(.*?)\](.*?)\[\/mail\]/is',
    '/\[mail\](.*?)\[\/mail\]/is',
    '/\[color\=(.*?)\](.*?)\[\/color\]/is',
  );
  $bb_replace = array(
    'mn_highlight_string(\'$1\')',
    '<br />',
    '<strong>$1</strong>',
    '<em>$1</em>',
    '<u>$1</u>',
    '<a href="$1"'.$target.'>$2</a>',
    '<a href="$1"'.$target.'>$1</a>',
    '<a href="mailto:$1">$2</a>',
    '<a href="mailto:$1">$1</a>',
    '<span style="color: $1;">$2</span>',
  );
  $bb_no_replace = array(
    '$1',
    '<br />',
    '$1',
    '$1',
    '$1',
    '$2: $1',
    '$1',
    '$2: $1',
    '$1',
    '$2',
  );

  $smiles_search = array(
    '/:-?\[/is',
    '/:beer:/is',
    '/8-?\)/is',
    '/[;:],?-?\(/is',
    '/\]:-?[\)D]?/is',
    '/:fuck:/is',
    '/;-?D+/is',
    '/:jokingly:/is',
    '/:-?\*/is',
    '/:-?D+/is',
    '/:love:/is',
    '/:ninja:/is',
    '/:no:/is',
    '/:-?\(/is',
    '/:-?\)/is',
    '/:stop:/is',
    '/[:8]-?O/is',
    '/[;:]-?P/is',
    '/:-\//is',
    '/:-?\?/is',
    '/:whistle:/is',
    '/;-?\)/is',
    '/:yes:/is',
    '/:zzz:/is',
  ); 
  $smiles_replace = array(
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-angry.gif' width='16' height='16' alt=':-[' title=':-[' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-beer.gif' width='16' height='16' alt='beer' title='beer' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-cool.gif' width='16' height='16' alt='8-)' title='8-)' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-cry.gif' width='16' height='16' alt=';,(' title=';,(' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-evil.gif' width='16' height='16' alt='evil' title='evil' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-fuck.gif' width='16' height='16' alt='fuck' title='fuck' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-grin.gif' width='16' height='16' alt=';-D' title=';-D' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-jokingly.gif' width='16' height='16' alt='jokingly' title='jokingly' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-kiss.gif' width='16' height='16' alt=':-*' title=':-*' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-lol.gif' width='16' height='16' alt=':-D' title=':-D' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-love.gif' width='16' height='16' alt='love' title='love' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-ninja.gif' width='16' height='16' alt='ninja' title='ninja' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-no.gif' width='16' height='16' alt='no!' title='no!' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-sad.gif' width='16' height='16' alt=':-(' title=':-(' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-smile.gif' width='16' height='16' alt=':-)' title=':-)' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-stop.gif' width='16' height='16' alt='stop' title='stop' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-surprised.gif' width='16' height='16' alt=':-O' title=':-O' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-tongue.gif' width='16' height='16' alt=':-P' title=':-P' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-undecided.gif' width='16' height='16' alt=':-/' title=':-/' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-what.gif' width='16' height='16' alt=':-?' title=':-?' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-whistle.gif' width='16' height='16' alt='whistle' title='whistle' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-wink.gif' width='16' height='16' alt=';-)' title=';-)' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-yes.gif' width='16' height='16' alt='yes' title='yes' />",
    "<img src='" . $conf['mnews_url_path'] . "/stuff/img/smiles/smiley-zzz.gif' width='16' height='16' alt='zzz' title='zzz' />",
  ); 

  if ($conf['comments_bb']) {$str = preg_replace($bb_search, $bb_replace, $str);}
  else {$str = preg_replace($bb_search, $bb_no_replace, $str);}
  if ($conf['comments_smiles']) {$str = preg_replace($smiles_search, $smiles_replace, $str);}

  return strip_slashes($str); 
}





// zistenie aktuálnosti verzie MNews
function get_latest_version() {
  $errmsg=false;
  $fp = @fsockopen("mnews.php5.sk", 80, $errno, $errstr, 30);
  if (!$fp) {return "";}
  else {
    $out = "GET /version.txt HTTP/1.1\r\n";
    $out .= "Host: mnews.php5.sk\r\n";
    $out .= "Connection: Close\r\n\r\n";

    fwrite($fp, $out);
    while (!feof($fp)) {
      $latest_version_number = fgets($fp, 128);
    }
    fclose($fp);
    return trim($latest_version_number);
  }
}





/**
 * Make hyperlinks clickable
 *
 * @copyright Copyright (C) 2008 PunBB, partially based on code copyright (C) 2008 FluxBB.org
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * @package PunBB
 */
function do_clickable($text) {
	$text = ' '.$text;

	$text = preg_replace('#(?<=[\s\]\)])(<)?(\[)?(\()?([\'"]?)(https?|ftp|news){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\s\[]*[^\s.,?!\[;:-]?)?)\4(?(3)(\)))(?(2)(\]))(?(1)(>))(?![^\s]*\[/(?:url|img)\])#ie', 'stripslashes(\'$1$2$3$4\').handle_url_tag(\'$5://$6\', \'$5://$6\', true).stripslashes(\'$4$10$11$12\')', $text);
	$text = preg_replace('#(?<=[\s\]\)])(<)?(\[)?(\()?([\'"]?)(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^\s\[]*[^\s.,?!\[;:-])?)\4(?(3)(\)))(?(2)(\]))(?(1)(>))(?![^\s]*\[/(?:url|img)\])#ie', 'stripslashes(\'$1$2$3$4\').handle_url_tag(\'$5.$6\', \'$5.$6\', true).stripslashes(\'$4$10$11$12\')', $text);

	return substr($text, 1);
}

function handle_url_tag($url, $link = '') {
  global $target;
	$full_url = str_replace(array(' ', '\'', '`', '"'), array('%20', '', '', ''), $url);
	if (strpos($url, 'www.') === 0)			// If it starts with www, we add http://
		$full_url = 'http://'.$full_url;
	elseif (strpos($url, 'ftp.') === 0)	// Else if it starts with ftp, we add ftp://
		$full_url = 'ftp://'.$full_url;
	elseif (!preg_match('#^([a-z0-9]{3,6})://#', $url)) 	// Else if it doesn't start with abcdef://, we add http://
		$full_url = 'http://'.$full_url;

	return '<a href="'.$full_url.'"'.$target.'>'.$link.'</a>';
}





/**
 * Charset-2-charset conversion by dgx
 * -----------------------------------
 *
 * This source file is subject to the GNU GPL license.
 *
 * @author     David Grudl <david@grudl.com>
 * @link       http://davidgrudl.com/
 * @copyright  Copyright (c) 2006 David Grudl
 * @license    GNU GENERAL PUBLIC LICENSE
 * @category   Text
 * @version    1.0
 */

//  UTF-8 to WINDOWS-1250
function utf2win($s) {
  $s = preg_replace('#[^\x00-\x7F\xa0\xa4\xa6-\xa9\xab-\xae\xb0\xb1\xb4-\xb8\xbb\xc1\xc2\xc4\xc7\xc9\xcb\xcd\xce\xd3\xd4\xd6\xd7\xda\xdc\xdd\xdf\xe1\xe2\xe4\xe7\xe9\xeb\xed\xee\xf3\xf4\xf6\xf7\xfa\xfc\xfd\x{102}-\x{107}\x{10c}-\x{111}\x{118}-\x{11b}\x{139}\x{13a}\x{13d}\x{13e}\x{141}-\x{144}\x{147}\x{148}\x{150}\x{151}\x{154}\x{155}\x{158}-\x{15b}\x{15e}-\x{165}\x{16e}-\x{171}\x{179}-\x{17e}\x{2c7}\x{2d8}\x{2d9}\x{2db}\x{2dd}\x{2013}\x{2014}\x{2018}-\x{201a}\x{201c}-\x{201e}\x{2020}-\x{2022}\x{2026}\x{2030}\x{2039}\x{203a}\x{20ac}\x{2122}]#u', '', $s);
  static $tbl = array("\xe2\x82\xac"=>"\x80","\xe2\x80\x9a"=>"\x82","\xe2\x80\x9e"=>"\x84","\xe2\x80\xa6"=>"\x85","\xe2\x80\xa0"=>"\x86","\xe2\x80\xa1"=>"\x87","\xe2\x80\xb0"=>"\x89","\xc5\xa0"=>"\x8a","\xe2\x80\xb9"=>"\x8b","\xc5\x9a"=>"\x8c","\xc5\xa4"=>"\x8d","\xc5\xbd"=>"\x8e","\xc5\xb9"=>"\x8f","\xe2\x80\x98"=>"\x91","\xe2\x80\x99"=>"\x92","\xe2\x80\x9c"=>"\x93","\xe2\x80\x9d"=>"\x94","\xe2\x80\xa2"=>"\x95","\xe2\x80\x93"=>"\x96","\xe2\x80\x94"=>"\x97","\xe2\x84\xa2"=>"\x99","\xc5\xa1"=>"\x9a","\xe2\x80\xba"=>"\x9b","\xc5\x9b"=>"\x9c","\xc5\xa5"=>"\x9d","\xc5\xbe"=>"\x9e","\xc5\xba"=>"\x9f","\xc2\xa0"=>"\xa0","\xcb\x87"=>"\xa1","\xcb\x98"=>"\xa2","\xc5\x81"=>"\xa3","\xc2\xa4"=>"\xa4","\xc4\x84"=>"\xa5","\xc2\xa6"=>"\xa6","\xc2\xa7"=>"\xa7","\xc2\xa8"=>"\xa8","\xc2\xa9"=>"\xa9","\xc5\x9e"=>"\xaa","\xc2\xab"=>"\xab","\xc2\xac"=>"\xac","\xc2\xad"=>"\xad","\xc2\xae"=>"\xae","\xc5\xbb"=>"\xaf","\xc2\xb0"=>"\xb0","\xc2\xb1"=>"\xb1","\xcb\x9b"=>"\xb2","\xc5\x82"=>"\xb3","\xc2\xb4"=>"\xb4","\xc2\xb5"=>"\xb5","\xc2\xb6"=>"\xb6","\xc2\xb7"=>"\xb7","\xc2\xb8"=>"\xb8","\xc4\x85"=>"\xb9","\xc5\x9f"=>"\xba","\xc2\xbb"=>"\xbb","\xc4\xbd"=>"\xbc","\xcb\x9d"=>"\xbd","\xc4\xbe"=>"\xbe","\xc5\xbc"=>"\xbf","\xc5\x94"=>"\xc0","\xc3\x81"=>"\xc1","\xc3\x82"=>"\xc2","\xc4\x82"=>"\xc3","\xc3\x84"=>"\xc4","\xc4\xb9"=>"\xc5","\xc4\x86"=>"\xc6","\xc3\x87"=>"\xc7","\xc4\x8c"=>"\xc8","\xc3\x89"=>"\xc9","\xc4\x98"=>"\xca","\xc3\x8b"=>"\xcb","\xc4\x9a"=>"\xcc","\xc3\x8d"=>"\xcd","\xc3\x8e"=>"\xce","\xc4\x8e"=>"\xcf","\xc4\x90"=>"\xd0","\xc5\x83"=>"\xd1","\xc5\x87"=>"\xd2","\xc3\x93"=>"\xd3","\xc3\x94"=>"\xd4","\xc5\x90"=>"\xd5","\xc3\x96"=>"\xd6","\xc3\x97"=>"\xd7","\xc5\x98"=>"\xd8","\xc5\xae"=>"\xd9","\xc3\x9a"=>"\xda","\xc5\xb0"=>"\xdb","\xc3\x9c"=>"\xdc","\xc3\x9d"=>"\xdd","\xc5\xa2"=>"\xde","\xc3\x9f"=>"\xdf","\xc5\x95"=>"\xe0","\xc3\xa1"=>"\xe1","\xc3\xa2"=>"\xe2","\xc4\x83"=>"\xe3","\xc3\xa4"=>"\xe4","\xc4\xba"=>"\xe5","\xc4\x87"=>"\xe6","\xc3\xa7"=>"\xe7","\xc4\x8d"=>"\xe8","\xc3\xa9"=>"\xe9","\xc4\x99"=>"\xea","\xc3\xab"=>"\xeb","\xc4\x9b"=>"\xec","\xc3\xad"=>"\xed","\xc3\xae"=>"\xee","\xc4\x8f"=>"\xef","\xc4\x91"=>"\xf0","\xc5\x84"=>"\xf1","\xc5\x88"=>"\xf2","\xc3\xb3"=>"\xf3","\xc3\xb4"=>"\xf4","\xc5\x91"=>"\xf5","\xc3\xb6"=>"\xf6","\xc3\xb7"=>"\xf7","\xc5\x99"=>"\xf8","\xc5\xaf"=>"\xf9","\xc3\xba"=>"\xfa","\xc5\xb1"=>"\xfb","\xc3\xbc"=>"\xfc","\xc3\xbd"=>"\xfd","\xc5\xa3"=>"\xfe","\xcb\x99"=>"\xff");
  return strtr($s, $tbl);
}


//  UTF-8 to ISO-8859-2
function utf2iso($s) {
  $s = preg_replace('#[^\x00-\x7F\xa0\xa4\xa7\xa8\xad\xb0\xb4\xb8\xc1\xc2\xc4\xc7\xc9\xcb\xcd\xce\xd3\xd4\xd6\xd7\xda\xdc\xdd\xdf\xe1\xe2\xe4\xe7\xe9\xeb\xed\xee\xf3\xf4\xf6\xf7\xfa\xfc\xfd\x{102}-\x{107}\x{10c}-\x{111}\x{118}-\x{11b}\x{139}\x{13a}\x{13d}\x{13e}\x{141}-\x{144}\x{147}\x{148}\x{150}\x{151}\x{154}\x{155}\x{158}-\x{15b}\x{15e}-\x{165}\x{16e}-\x{171}\x{179}-\x{17e}\x{2c7}\x{2d8}\x{2d9}\x{2db}\x{2dd}]#u', '', $s);
  static $tbl = array("\xc2\xa0"=>"\xa0","\xc4\x84"=>"\xa1","\xcb\x98"=>"\xa2","\xc5\x81"=>"\xa3","\xc2\xa4"=>"\xa4","\xc4\xbd"=>"\xa5","\xc5\x9a"=>"\xa6","\xc2\xa7"=>"\xa7","\xc2\xa8"=>"\xa8","\xc5\xa0"=>"\xa9","\xc5\x9e"=>"\xaa","\xc5\xa4"=>"\xab","\xc5\xb9"=>"\xac","\xc2\xad"=>"\xad","\xc5\xbd"=>"\xae","\xc5\xbb"=>"\xaf","\xc2\xb0"=>"\xb0","\xc4\x85"=>"\xb1","\xcb\x9b"=>"\xb2","\xc5\x82"=>"\xb3","\xc2\xb4"=>"\xb4","\xc4\xbe"=>"\xb5","\xc5\x9b"=>"\xb6","\xcb\x87"=>"\xb7","\xc2\xb8"=>"\xb8","\xc5\xa1"=>"\xb9","\xc5\x9f"=>"\xba","\xc5\xa5"=>"\xbb","\xc5\xba"=>"\xbc","\xcb\x9d"=>"\xbd","\xc5\xbe"=>"\xbe","\xc5\xbc"=>"\xbf","\xc5\x94"=>"\xc0","\xc3\x81"=>"\xc1","\xc3\x82"=>"\xc2","\xc4\x82"=>"\xc3","\xc3\x84"=>"\xc4","\xc4\xb9"=>"\xc5","\xc4\x86"=>"\xc6","\xc3\x87"=>"\xc7","\xc4\x8c"=>"\xc8","\xc3\x89"=>"\xc9","\xc4\x98"=>"\xca","\xc3\x8b"=>"\xcb","\xc4\x9a"=>"\xcc","\xc3\x8d"=>"\xcd","\xc3\x8e"=>"\xce","\xc4\x8e"=>"\xcf","\xc4\x90"=>"\xd0","\xc5\x83"=>"\xd1","\xc5\x87"=>"\xd2","\xc3\x93"=>"\xd3","\xc3\x94"=>"\xd4","\xc5\x90"=>"\xd5","\xc3\x96"=>"\xd6","\xc3\x97"=>"\xd7","\xc5\x98"=>"\xd8","\xc5\xae"=>"\xd9","\xc3\x9a"=>"\xda","\xc5\xb0"=>"\xdb","\xc3\x9c"=>"\xdc","\xc3\x9d"=>"\xdd","\xc5\xa2"=>"\xde","\xc3\x9f"=>"\xdf","\xc5\x95"=>"\xe0","\xc3\xa1"=>"\xe1","\xc3\xa2"=>"\xe2","\xc4\x83"=>"\xe3","\xc3\xa4"=>"\xe4","\xc4\xba"=>"\xe5","\xc4\x87"=>"\xe6","\xc3\xa7"=>"\xe7","\xc4\x8d"=>"\xe8","\xc3\xa9"=>"\xe9","\xc4\x99"=>"\xea","\xc3\xab"=>"\xeb","\xc4\x9b"=>"\xec","\xc3\xad"=>"\xed","\xc3\xae"=>"\xee","\xc4\x8f"=>"\xef","\xc4\x91"=>"\xf0","\xc5\x84"=>"\xf1","\xc5\x88"=>"\xf2","\xc3\xb3"=>"\xf3","\xc3\xb4"=>"\xf4","\xc5\x91"=>"\xf5","\xc3\xb6"=>"\xf6","\xc3\xb7"=>"\xf7","\xc5\x99"=>"\xf8","\xc5\xaf"=>"\xf9","\xc3\xba"=>"\xfa","\xc5\xb1"=>"\xfb","\xc3\xbc"=>"\xfc","\xc3\xbd"=>"\xfd","\xc5\xa3"=>"\xfe","\xcb\x99"=>"\xff");
  return strtr($s, $tbl);
}


// WINDOWS-1250 to UTF-8 
function win2utf($s) { 
  static $tbl = array("\x80"=>"\xe2\x82\xac","\x81"=>"","\x82"=>"\xe2\x80\x9a","\x83"=>"","\x84"=>"\xe2\x80\x9e","\x85"=>"\xe2\x80\xa6","\x86"=>"\xe2\x80\xa0","\x87"=>"\xe2\x80\xa1","\x88"=>"","\x89"=>"\xe2\x80\xb0","\x8a"=>"\xc5\xa0","\x8b"=>"\xe2\x80\xb9","\x8c"=>"\xc5\x9a","\x8d"=>"\xc5\xa4","\x8e"=>"\xc5\xbd","\x8f"=>"\xc5\xb9","\x90"=>"","\x91"=>"\xe2\x80\x98","\x92"=>"\xe2\x80\x99","\x93"=>"\xe2\x80\x9c","\x94"=>"\xe2\x80\x9d","\x95"=>"\xe2\x80\xa2","\x96"=>"\xe2\x80\x93","\x97"=>"\xe2\x80\x94","\x98"=>"","\x99"=>"\xe2\x84\xa2","\x9a"=>"\xc5\xa1","\x9b"=>"\xe2\x80\xba","\x9c"=>"\xc5\x9b","\x9d"=>"\xc5\xa5","\x9e"=>"\xc5\xbe","\x9f"=>"\xc5\xba","\xa0"=>"\xc2\xa0","\xa1"=>"\xcb\x87","\xa2"=>"\xcb\x98","\xa3"=>"\xc5\x81","\xa4"=>"\xc2\xa4","\xa5"=>"\xc4\x84","\xa6"=>"\xc2\xa6","\xa7"=>"\xc2\xa7","\xa8"=>"\xc2\xa8","\xa9"=>"\xc2\xa9","\xaa"=>"\xc5\x9e","\xab"=>"\xc2\xab","\xac"=>"\xc2\xac","\xad"=>"\xc2\xad","\xae"=>"\xc2\xae","\xaf"=>"\xc5\xbb","\xb0"=>"\xc2\xb0","\xb1"=>"\xc2\xb1","\xb2"=>"\xcb\x9b","\xb3"=>"\xc5\x82","\xb4"=>"\xc2\xb4","\xb5"=>"\xc2\xb5","\xb6"=>"\xc2\xb6","\xb7"=>"\xc2\xb7","\xb8"=>"\xc2\xb8","\xb9"=>"\xc4\x85","\xba"=>"\xc5\x9f","\xbb"=>"\xc2\xbb","\xbc"=>"\xc4\xbd","\xbd"=>"\xcb\x9d","\xbe"=>"\xc4\xbe","\xbf"=>"\xc5\xbc","\xc0"=>"\xc5\x94","\xc1"=>"\xc3\x81","\xc2"=>"\xc3\x82","\xc3"=>"\xc4\x82","\xc4"=>"\xc3\x84","\xc5"=>"\xc4\xb9","\xc6"=>"\xc4\x86","\xc7"=>"\xc3\x87","\xc8"=>"\xc4\x8c","\xc9"=>"\xc3\x89","\xca"=>"\xc4\x98","\xcb"=>"\xc3\x8b","\xcc"=>"\xc4\x9a","\xcd"=>"\xc3\x8d","\xce"=>"\xc3\x8e","\xcf"=>"\xc4\x8e","\xd0"=>"\xc4\x90","\xd1"=>"\xc5\x83","\xd2"=>"\xc5\x87","\xd3"=>"\xc3\x93","\xd4"=>"\xc3\x94","\xd5"=>"\xc5\x90","\xd6"=>"\xc3\x96","\xd7"=>"\xc3\x97","\xd8"=>"\xc5\x98","\xd9"=>"\xc5\xae","\xda"=>"\xc3\x9a","\xdb"=>"\xc5\xb0","\xdc"=>"\xc3\x9c","\xdd"=>"\xc3\x9d","\xde"=>"\xc5\xa2","\xdf"=>"\xc3\x9f","\xe0"=>"\xc5\x95","\xe1"=>"\xc3\xa1","\xe2"=>"\xc3\xa2","\xe3"=>"\xc4\x83","\xe4"=>"\xc3\xa4","\xe5"=>"\xc4\xba","\xe6"=>"\xc4\x87","\xe7"=>"\xc3\xa7","\xe8"=>"\xc4\x8d","\xe9"=>"\xc3\xa9","\xea"=>"\xc4\x99","\xeb"=>"\xc3\xab","\xec"=>"\xc4\x9b","\xed"=>"\xc3\xad","\xee"=>"\xc3\xae","\xef"=>"\xc4\x8f","\xf0"=>"\xc4\x91","\xf1"=>"\xc5\x84","\xf2"=>"\xc5\x88","\xf3"=>"\xc3\xb3","\xf4"=>"\xc3\xb4","\xf5"=>"\xc5\x91","\xf6"=>"\xc3\xb6","\xf7"=>"\xc3\xb7","\xf8"=>"\xc5\x99","\xf9"=>"\xc5\xaf","\xfa"=>"\xc3\xba","\xfb"=>"\xc5\xb1","\xfc"=>"\xc3\xbc","\xfd"=>"\xc3\xbd","\xfe"=>"\xc5\xa3","\xff"=>"\xcb\x99"); 
  return strtr($s, $tbl); 
}


// ISO-8859-2 to UTF-8 
function iso2utf($s) { 
  static $tbl = array("\x80"=>"","\x81"=>"","\x82"=>"","\x83"=>"","\x84"=>"","\x85"=>"","\x86"=>"","\x87"=>"","\x88"=>"","\x89"=>"","\x8a"=>"","\x8b"=>"","\x8c"=>"","\x8d"=>"","\x8e"=>"","\x8f"=>"","\x90"=>"","\x91"=>"","\x92"=>"","\x93"=>"","\x94"=>"","\x95"=>"","\x96"=>"","\x97"=>"","\x98"=>"","\x99"=>"","\x9a"=>"","\x9b"=>"","\x9c"=>"","\x9d"=>"","\x9e"=>"","\x9f"=>"","\xa0"=>"\xc2\xa0","\xa1"=>"\xc4\x84","\xa2"=>"\xcb\x98","\xa3"=>"\xc5\x81","\xa4"=>"\xc2\xa4","\xa5"=>"\xc4\xbd","\xa6"=>"\xc5\x9a","\xa7"=>"\xc2\xa7","\xa8"=>"\xc2\xa8","\xa9"=>"\xc5\xa0","\xaa"=>"\xc5\x9e","\xab"=>"\xc5\xa4","\xac"=>"\xc5\xb9","\xad"=>"\xc2\xad","\xae"=>"\xc5\xbd","\xaf"=>"\xc5\xbb","\xb0"=>"\xc2\xb0","\xb1"=>"\xc4\x85","\xb2"=>"\xcb\x9b","\xb3"=>"\xc5\x82","\xb4"=>"\xc2\xb4","\xb5"=>"\xc4\xbe","\xb6"=>"\xc5\x9b","\xb7"=>"\xcb\x87","\xb8"=>"\xc2\xb8","\xb9"=>"\xc5\xa1","\xba"=>"\xc5\x9f","\xbb"=>"\xc5\xa5","\xbc"=>"\xc5\xba","\xbd"=>"\xcb\x9d","\xbe"=>"\xc5\xbe","\xbf"=>"\xc5\xbc","\xc0"=>"\xc5\x94","\xc1"=>"\xc3\x81","\xc2"=>"\xc3\x82","\xc3"=>"\xc4\x82","\xc4"=>"\xc3\x84","\xc5"=>"\xc4\xb9","\xc6"=>"\xc4\x86","\xc7"=>"\xc3\x87","\xc8"=>"\xc4\x8c","\xc9"=>"\xc3\x89","\xca"=>"\xc4\x98","\xcb"=>"\xc3\x8b","\xcc"=>"\xc4\x9a","\xcd"=>"\xc3\x8d","\xce"=>"\xc3\x8e","\xcf"=>"\xc4\x8e","\xd0"=>"\xc4\x90","\xd1"=>"\xc5\x83","\xd2"=>"\xc5\x87","\xd3"=>"\xc3\x93","\xd4"=>"\xc3\x94","\xd5"=>"\xc5\x90","\xd6"=>"\xc3\x96","\xd7"=>"\xc3\x97","\xd8"=>"\xc5\x98","\xd9"=>"\xc5\xae","\xda"=>"\xc3\x9a","\xdb"=>"\xc5\xb0","\xdc"=>"\xc3\x9c","\xdd"=>"\xc3\x9d","\xde"=>"\xc5\xa2","\xdf"=>"\xc3\x9f","\xe0"=>"\xc5\x95","\xe1"=>"\xc3\xa1","\xe2"=>"\xc3\xa2","\xe3"=>"\xc4\x83","\xe4"=>"\xc3\xa4","\xe5"=>"\xc4\xba","\xe6"=>"\xc4\x87","\xe7"=>"\xc3\xa7","\xe8"=>"\xc4\x8d","\xe9"=>"\xc3\xa9","\xea"=>"\xc4\x99","\xeb"=>"\xc3\xab","\xec"=>"\xc4\x9b","\xed"=>"\xc3\xad","\xee"=>"\xc3\xae","\xef"=>"\xc4\x8f","\xf0"=>"\xc4\x91","\xf1"=>"\xc5\x84","\xf2"=>"\xc5\x88","\xf3"=>"\xc3\xb3","\xf4"=>"\xc3\xb4","\xf5"=>"\xc5\x91","\xf6"=>"\xc3\xb6","\xf7"=>"\xc3\xb7","\xf8"=>"\xc5\x99","\xf9"=>"\xc5\xaf","\xfa"=>"\xc3\xba","\xfb"=>"\xc5\xb1","\xfc"=>"\xc3\xbc","\xfd"=>"\xc3\xbd","\xfe"=>"\xc5\xa3","\xff"=>"\xcb\x99"); 
  return strtr($s, $tbl); 
}
?>
